#!/bin/bash

DIR=`pwd`

for i in \
 pv_tk \
 pv_gl \
 pv_cl \
 pv \
 include \

do
 cd $DIR/src/$i
 rm -f *~
 rm -f *.BAK
 rm -f *.o
 rm -f *.obj
 rm -f *"conflicted copy"*
 rm -f *_
 rm -f *\#
done

for i in \
 iString \
 Dvector3D \
 ViewAtom \
 ViewBond \
 Atom \
 Bond \
 Fragment \
 LinkGroup \
 BioUnit \
 Molecule \
 Trajectory \
 Eye \
 PVGraph \
 PaicsResult \
 iRectangle \
 ForceField \
 docking \
 Dihedral \
 Angle \

do
 cd $DIR/src/class/$i
 rm -f *.BAK
 rm -f *.o
 rm -f *.obj
 rm -f *~
 rm -f *"conflicted copy"*
done

 cd $DIR/
 rm -f *~
 rm -f *_
 rm -f *.BAK
 rm -f *.exe
 rm -f *.o
 rm -f *.obj
 rm -f *"conflicted copy"*
 rm -f *.stackdump
#rm -f *out
#rm -f *inp
#rm -f *top
#rm -f *rst
#rm -f *aaa
#rm -f *bbb
#rm -f *trjb
#rm -f *trj
#rm -f *pdb
#rm -f *xyz
#rm -f *cntrl
 rm -f tools/*.cube
 rm -f frag*load
 rm -f frag*ps
 rm -f frag*dat
 rm -f frag*dvi
 rm -f frag*pdf
 rm -f frag*tex
 rm -f frag*aux
 rm -f frag*log
 rm -f texput.log
