
////////////////////                               ///////////////////
////////////////////     Angle class ; Header      ///////////////////
////////////////////                               ///////////////////

#ifndef _ISHI_ANGLE_H_
#define _ISHI_ANGLE_H_

#include <string>
#include "Dvector3D.h"

using namespace std;

class Angle{

 public:

  /*-------------------*/
  /*--- constractor ---*/
  /*-------------------*/

  Angle ( ) ;    
  Angle ( const int ia1, const int ia2, const int ia3 ) ;
  Angle ( const Angle& an ) ;

  /*------------------*/
  /*--- destractor ---*/
  /*------------------*/
  
  ~Angle ( ) ;

  /*------------*/
  /*--- copy ---*/
  /*------------*/
  
  void copy ( const Angle& an ) ;
  
  int get_iatom1 ( ) const ;
  int get_iatom2 ( ) const ;
  int get_iatom3 ( ) const ; 

  void set_iatom1(const int ia_);
  void set_iatom2(const int ia_);
  void set_iatom3(const int ia_);

  static double calc(const double    x1,
		     const double    y1,
		     const double    z1,
		     const double    x2,
		     const double    y2,
		     const double    z2,
		     const double    x3,
		     const double    y3,
		     const double    z3);

  static double calc(const Dvector3D r1,
		     const Dvector3D r2,
		     const Dvector3D r3);
  
 private:
  
  int iatom1;
  int iatom2;
  int iatom3;
};

#endif
