
#include <cstdlib>
#include <iostream>
#include <cstring>
#include "iString.h"

using namespace std ;

int iFind(const char* a, const string& b, const int max)
{
  int i=0, chk;  
  while(!a[i]=='\0'){
    chk=1;
    for(unsigned int j=0;j<b.length();j++){
      if(a[i+j]!=b.at(j)){
        chk=0;
        break;
      }
    }
    if(chk==1){return i;}
    i++;
    if(i>=max){
      break;
    }
  }
  return -1;
}

int iPos(const char* a, const int n, const int type)
{
  int pos=0;
  int i=0;
  while(!a[pos]=='\0'){
    if(n==i) break ;
    if(a[pos]==' '){
      i++;
      while(a[pos]==' '){
        if(a[pos]=='\0') return -1;
        pos++;
      }
      pos--;
    }
    pos++;
  }
  if(type==0) return pos;
  if(type==1){
    while(!a[pos]=='\0'){
      pos++;
      if(a[pos]==' ' || a[pos]=='\0'){
        return pos-1;
      }
    }
  }
  return -1;
}

char* iPickUp(const char* a, const int n, char* buff)
{
  int i=0;
  int count=0;
  while(!a[i]=='\0'){
    if(a[i]!=' '){
      int j=0;
      while(!(a[i+j]==' ' || a[i+j]=='\0')){
        buff[j]=a[i+j];
        j++;
      }
      if(count==n){
        buff[j]='\0';
        return buff;
      }
      count++;
      i=i+j+1;
    } else {
      i++;
    }
  }
  return buff;
}

int iPickUpNum(const char* a)
{
  int i=0;
  int count=0;
  while(!a[i]=='\0'){
    if(a[i]!=' '){
      int j=0;
      while(!(a[i+j]==' ' || a[i+j]=='\0')){
        j++;
      }
      count++;
      i=i+j;
    } else {
      i++;
    }
  }
  return count;
}

char* iPickUpline(const char* a, const int n, char* buff)
{
  int i=0;
  int count=0;
  while(!a[i]=='\0'){
    if(a[i]!='\n'){
      int j=0;
      while(!(a[i+j]=='\n' || a[i+j]=='\0')){
        buff[j]=a[i+j];
        j++;
      }
      if(count==n){
        buff[j]='\0';
        return buff;
      }
      count++;
      i=i+j+1;
    } else {
      i++;
    }
  }
  return buff;
}

void iPickUpline(const string s, string* buff)
{
  int il=0;
  for(int i=0;i<s.size();i++){
    if(s[i]!='\n'){
      buff[il]=buff[il]+s[i];
    } else {
      il++;
    }
  }
}

int iPickUplineNum (const string s)
{
  int nl=0;
  for(int i=0;i<s.size();i++){
    if(s[i]=='\n'){
      nl++;
    }
  }
  return nl;
}

int iPickUplineNum (const char* a)
{
  int i=0;
  int count=0;
  while(!a[i]=='\0'){
    if(a[i]!='\n'){
      int j=0;
      while(!(a[i+j]=='\n' || a[i+j]=='\0')){
        j++;
      }
      count++;
      i=i+j;
    } else {
      i++;
    }
  }
  return count;
}

int iGetList(const char* list_in,
             int* list_out,
             const int max,
             const int get_list)
{
  int n=0;
  int i=0;
  int j=0;
  int k=0;
  int l=0;
  int in=0;
  int ibuf,i1,i2,chk_max;
  char buf[1024];
  char buf1[16];
  char buf2[16];
  if(max==0){
    return 0 ;
  }
  if(list_in[0]=='\0'){
    return 0 ;
  }
  while(1){
    if(i>65536){
      return 0;
    }
    if(list_in[i]=='\0' || list_in[i]==','){
      buf[i-j]='\0';
      j=i+1;
      k=0;
      while(1){
        if(buf[k]=='-' ) {ibuf=k;break;}
        if(buf[k]=='\0') {ibuf=0;break;}
        k++;
      }
      if(ibuf>0){
        l=0;for(k=0;k<ibuf;k++)     {buf1[l]=buf[k];l++;}
        l=0;for(k=(ibuf+1);k<in;k++){buf2[l]=buf[k];l++;}
        buf1[ibuf     ]='\0';
        buf2[in-ibuf-1]='\0';
        int chk1=0;
        int chk2=0;
        if(iCheckNumber(buf1)){
          chk1=1;
        }
        chk_max=0;
        if(strcmp(buf2,"ALL" )==0) {chk_max=1;chk2=1;}
        if(strcmp(buf2,"All" )==0) {chk_max=1;chk2=1;}
        if(strcmp(buf2,"all" )==0) {chk_max=1;chk2=1;}
        if(strcmp(buf2,"max" )==0) {chk_max=1;chk2=1;}
        if(strcmp(buf2,"MAX" )==0) {chk_max=1;chk2=1;}
        if(strcmp(buf2,"Max" )==0) {chk_max=1;chk2=1;}
        if(strcmp(buf2,"LAST")==0) {chk_max=1;chk2=1;}
        if(strcmp(buf2,"Last")==0) {chk_max=1;chk2=1;}
        if(strcmp(buf2,"last")==0) {chk_max=1;chk2=1;}
        if(strcmp(buf2,"END" )==0) {chk_max=1;chk2=1;}
        if(strcmp(buf2,"End" )==0) {chk_max=1;chk2=1;}
        if(strcmp(buf2,"end" )==0) {chk_max=1;chk2=1;}
        if(chk2==0){
          if(iCheckNumber(buf2)){
            chk2=1;
          }
        }
        if(chk1==1 && chk2==1){
          i1=atoi(buf1);
          if(max>=0 && i1>max){
            // not a correct region
            i1=1;
            i2=0;
          } else {
            if(chk_max==1){
              i2=max;
            } else {
              i2=atoi(buf2);
              if(max>=0 && i2>max){
                // not a correct region
                i1=1;
                i2=0;
              }
            }
          }
        } else {
          // not a correct region
          i1= 1;
          i2= 0;
        }
      }
      if(ibuf==0){
        int chkchk=0;
        if(strcmp(buf,"ALL" )==0) chkchk=1;
        if(strcmp(buf,"All" )==0) chkchk=1;
        if(strcmp(buf,"all" )==0) chkchk=1;
        if(chkchk==1){
          i1=1;
          i2=max;
        } else {
          if(iCheckNumber(buf)){
            i1=atoi(buf);
            i2=atoi(buf);
            if(max>=0 && i2>max){
              // not a correct region
              i1=1;
              i2=0;
            }
          } else {
            // not a correct region
            i1= 1;
            i2= 0;
          }
        }
      }
      for(k=i1;k<=i2;k++){
        if(get_list==1){
          list_out[n]=k;
        }
        n++;
      }
      in=0;
    } else {
      in++;
      buf[i-j]=list_in[i];
    }
    if(list_in[i]=='\0') break ;
    i++;
  }
  return n; 
}

int iGetListNum(const char* list_in, const int max)
{
  int * dummy = new int [1]; 
  int n=iGetList(list_in,dummy,max,0);
  delete [] dummy;
  return n;
}

int iCheckNumber(const char* in, const int max)
{
  int chk=0;
  int i=0;
  while(1){
    if(i==max){
      chk=999;
      break;
    }
    if(in[i]=='\0'){
      break;
    } else {
      if(0){}
      else if(in[i]=='0') {}
      else if(in[i]=='1') {}
      else if(in[i]=='2') {}
      else if(in[i]=='3') {}
      else if(in[i]=='4') {}
      else if(in[i]=='5') {}
      else if(in[i]=='6') {}
      else if(in[i]=='7') {}
      else if(in[i]=='8') {}
      else if(in[i]=='9') {}
      else {
        chk=999;
        break;
      }
    }
    i++;
  }
  if(chk==0){
    return 1;
  } else {
    return 0;
  }
}

/*
int iGetListNum(const char* list_in, const int max)
{
  int n=0;
  int i=0;
  int j=0;
  int k=0;
  int l=0;
  int in=0;
  int ibuf,i1,i2,chk_max;
  char buf[1024];
  char buf1[16];
  char buf2[16];
  if(list_in[0]=='\0') return 0 ;
  while(1){
    if(i>65536) return 0;
    if(list_in[i]=='\0' || list_in[i]==','){
      buf[i-j]='\0';
      j=i+1;
      k=0;
      while(1){
        if(buf[k]=='-' ) {ibuf=k;break;}
        if(buf[k]=='\0') {ibuf=0;break;}
        k++;
      }
      if(ibuf>0){
        l=0;for(k=0;k<ibuf;k++)     {buf1[l]=buf[k];l++;}
        l=0;for(k=(ibuf+1);k<in;k++){buf2[l]=buf[k];l++;}
        buf1[ibuf     ]='\0';
        buf2[in-ibuf-1] ='\0';
        i1=atoi(buf1);
        chk_max=0;
        if(strcmp(buf2,"ALL" )==0) chk_max=1;
        if(strcmp(buf2,"All" )==0) chk_max=1;
        if(strcmp(buf2,"all" )==0) chk_max=1;
        if(strcmp(buf2,"max" )==0) chk_max=1;
        if(strcmp(buf2,"MAX" )==0) chk_max=1;
        if(strcmp(buf2,"Max" )==0) chk_max=1;
        if(strcmp(buf2,"LAST")==0) chk_max=1;
        if(strcmp(buf2,"Last")==0) chk_max=1;
        if(strcmp(buf2,"last")==0) chk_max=1;
        if(strcmp(buf2,"END" )==0) chk_max=1;
        if(strcmp(buf2,"End" )==0) chk_max=1;
        if(strcmp(buf2,"end" )==0) chk_max=1;
        if(chk_max==1){
          i2=max;
        } else {
          i2=atoi(buf2);
          if(max>=0 && i2>max){
            i2=max;
          }
        }
      }
      if(ibuf==0){
        i1=atoi(buf);
        i2=atoi(buf);        
      }
      for(k=i1;k<=i2;k++){
        n++;
      }
      in=0;
    } else {
      in++;
      buf[i-j]=list_in[i];
    }
    if(list_in[i]=='\0') break ;
    i++;
  }
  return n; 
}
*/

bool iCompareString(const char* s1, const char* s2, const int n)
{
  int i=0;
  while(i<n){
    if(s1[i]!='\0'){
      if(s1[i]!=s2[i]){
        return false;
      }
    } else {
      if(s2[i]=='\0'){
        return true;
      } else {
        return false;
      }
    }
    i++;
  }
  return false;
}

string iIntToString( const int  n  ,
                     const int  w  ,
                     const char cc )
{
  int i,l,c,p,chk_m;
  char* out = new char [w+1];
  string s;
  if(n>=0) chk_m=0;
  if(n <0) chk_m=1;
  for(i=0;i<w;i++) out[i]=cc;
  out[w]='\0';
  l=1;
  for(i=0;i<w;i++){
    if(chk_m==0) c=( n/l)%10;
    if(chk_m==1) c=(-n/l)%10;
    p=w-(i+1);
    switch(c){
    case 0 : { out[p]='0' ; break ; }
    case 1 : { out[p]='1' ; break ; }
    case 2 : { out[p]='2' ; break ; }
    case 3 : { out[p]='3' ; break ; }
    case 4 : { out[p]='4' ; break ; }
    case 5 : { out[p]='5' ; break ; }
    case 6 : { out[p]='6' ; break ; }
    case 7 : { out[p]='7' ; break ; }
    case 8 : { out[p]='8' ; break ; }
    case 9 : { out[p]='9' ; break ; }
    }
    l=l*10;
    if(chk_m==0 && l>( n)) break ;
    if(chk_m==1 && l>(-n)) break ;
  }
  if(chk_m==1){
    for(i=w-1;i>=0;i--){
      if(out[i]==cc){
        out[i]='-';
        break;
      }
    }
  }
  s=out;
  delete [] out ;
  return s;
}

string iIntToString( const int n )
{
  int l;
  int m=n;
  if(m<0) m=(-1)*m;
  if     ((m/10     )==0) {l=1;}
  else if((m/100    )==0) {l=2;}
  else if((m/1000   )==0) {l=3;}
  else if((m/10000  )==0) {l=4;}
  else if((m/100000 )==0) {l=5;}
  else if((m/1000000)==0) {l=6;}
  else {
    l=10;
  }
  if(n<0){
    l++;
  }
  return iIntToString(n,l);  
}

string iTrim(const char * in,
             const char c)
{
  string out="";
  int ipos=0;
  while(in[ipos]!='\0'){
    if(in[ipos]!=c){
      out=out+in[ipos];
    }
    ipos++;
  }
  return out;
}

string iListToString  ( const int     n         ,
                        const int*    list_in   )
{
  int imin,itmp;
  int * ibuf = new int [n+1];
  for(int i=0;i<n;i++){
    ibuf[i]=list_in[i];
  }
  for(int i=0;i<n-1;i++){
    imin=i;
    for(int j=i;j<n;j++){
      if(ibuf[j]<ibuf[imin]){
        imin=j;
      }
    }
    itmp=ibuf[i];
    ibuf[i]=ibuf[imin];
    ibuf[imin]=itmp;
  }
  string s="";
  for(int i=0;i<n;i++){
    if(i==0){s=s+iIntToString(ibuf[i]);}
    else if((ibuf[i]-ibuf[i-1])!=1){
      s=s+",";
      s=s+iIntToString(ibuf[i]);
    }
    else {
      if(i!=(n-1)){
        if((ibuf[i+1]-ibuf[i])!=1){
          s=s+"-";
          s=s+iIntToString(ibuf[i]);
        }
      } else {
        s=s+"-";
        s=s+iIntToString(ibuf[i]);
      }      
    }
  }
  delete [] ibuf;
  return s;
}

