#ifndef _ISHI_ISTRINGTOOLS_H_
#define _ISHI_ISTRINGTOOLS_H_

#include <string>

using namespace std ;

int    iFind          ( const char*   a         ,
                        const string& b         ,
			const int     max=1024  ) ;

int    iPos           ( const char*   a         ,
                        const int     n         ,
                        const int     type = 0  ) ;

char*  iPickUp        ( const char*   a         ,
                        const int     n         ,
                        char*         buff      ) ;

int    iPickUpNum     ( const char*   a         ) ;

char*  iPickUpline    ( const char*   a         ,
                        const int     n         ,
                        char*         buff      ) ;
void   iPickUpline    ( const string  s         ,
			string*       buff      );
int    iPickUplineNum ( const string  s         ) ;
int    iPickUplineNum ( const char*   a         ) ;

bool   iCompareString ( const char*   s1        ,
                        const char*   s2        ,
                        const int     n = 65536 ) ;

string iTrim          ( const char * in,
                        const char c=' ');

string iIntToString   ( const int     n         ,
                        const int     w         ,
                        const char    cc=' '    ) ;

string iIntToString   ( const int     n         ) ;

int    iGetList       ( const char*   list_in   ,
                        int*          list_out  ,
                        const int     max = -1  ,
                        const int     get_list=1);

int    iGetListNum    ( const char*   list_in   ,
                        const int     max = -1  );

int    iCheckNumber   ( const char*   in        ,
                        const int     max=16    );

string iListToString  ( const int     n         ,
                        const int*    list_in   );                        

#endif
